/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;namespace PluginIdea.HandleCameraForCreator{public class CoreModule : HCModuleBase{private List<string> aspectRadioPresets = new List<string>{"Custom", "16:9", "9:16", "16:10", "10:16", "4:3", "3:4", "2:1", "1:2", "1:1"};private float whAspectValue;private RenderTexture previewRT;private Vector3 startScale;private Vector2Int captureRTSize;private JSONStorableStringChooser aspectChooser;private JSONStorableFloat customAspect;private JSONStorableFloat intensity;private JSONStorableFloat heightPixelCount;private JSONStorableFloat previewHeightPixelCount;private JSONStorableFloat camScale;private JSONStorableFloat camFOV;private JSONStorableFloat nearCLip;private JSONStorableFloat farClip;private JSONStorableBool flip;private JSONStorableBool isFrontCamera;private JSONStorableBool isPBR;private bool isOnMonitorMode;public bool IsOnMonitorMode{set{isOnMonitorMode = value;if (value){whAspectValue = Screen.width / (float)Screen.height;ChangeRadio();}RefreshCamRT();}}public Vector2Int CaptureRTSize{get{return captureRTSize;}}public CoreModule(HandleCameraForCreator ower){this.ower = ower;}public override void Init(){Utils.CreateInfoText(ower, Location.GetStr(Location.PluginInfo), 400, true);Utils.CreateInfoTextNoScroll(this.ower, Location.GetStr(Location.CommonParametersSubtitle), 35, false);Utils.CreateSpacer(ower, 10,false);isFrontCamera = Utils.CreateToggle(ower, Location.GetStr(Location.UseFrontCamera), false, false, ower.bcs);isFrontCamera.setCallbackFunction = (val) =>{Quaternion rot = val ? Quaternion.Euler(0, 180, 0) : Quaternion.identity;ower.CurrentCam.transform.localRotation = rot;};camScale = Utils.CreateSliderFloat(ower, Location.GetStr(Location.CameraSize), 0.7f, 0.01f, 3, false, true);isPBR = Utils.CreateToggle(ower, Location.GetStr(Location.IsPBR), true, false, ower.bcs);isPBR.setCallbackFunction = (val) =>{ower.IsPBR = val;};intensity = Utils.CreateSliderFloat(ower, Location.GetStr(Location.Intensity), 1f, 0f, 3, false, ower.bcs);intensity.setCallbackFunction = (val) =>{Material mat = ower.Screen.material;float h, s, v;Color.RGBToHSV(mat.color,out h, out s, out v);v = val;mat.color = Color.HSVToRGB(h, s, v);};camFOV = Utils.CreateSliderFloat(ower, Location.GetStr(Location.CameraFOV), 60, 10, 180, false, ower.bcs);camFOV.setCallbackFunction = (val) =>{ower.CurrentCam.fieldOfView = val;};camScale.setCallbackFunction = (val) =>{ChangeRadio();};flip = Utils.CreateToggle(ower, Location.GetStr(Location.Flip), false, false, ower.bcs);flip.setCallbackFunction = (val) =>{Transform screenTrans = ower.Screen.transform;screenTrans.localScale = val ? new Vector3(-Mathf.Abs(screenTrans.localScale.x), screenTrans.localScale.y, screenTrans.localScale.z) :                new Vector3(Mathf.Abs(screenTrans.localScale.x), screenTrans.localScale.y, screenTrans.localScale.z);};Utils.CreateSpacer(ower, 20, false);nearCLip = Utils.CreateSliderFloat(ower, Location.GetStr(Location.NearCLip), 0.3f, 0, 10, false, ower.bcs);nearCLip.setCallbackFunction = (val) =>{ower.CurrentCam.nearClipPlane = val;};farClip = Utils.CreateSliderFloat(ower, Location.GetStr(Location.FarClip), 1000f, 1, 2000, false, ower.bcs);farClip.setCallbackFunction = (val) =>{ower.CurrentCam.farClipPlane = val;};Utils.CreateSpacer(ower,20, false);customAspect = Utils.CreateSliderFloat(ower, Location.GetStr(Location.CustomAspect), 1, 0.2f, 10f, false, ower.bcs);customAspect.setCallbackFunction = (val) =>{whAspectValue = customAspect.val;ChangeRadio();RefreshCamRT();};aspectChooser = Utils.CreateStringChooser(ower, Location.GetStr(Location.Aspect), aspectRadioPresets, false, ower.bcs);aspectChooser.setCallbackFunction = (val) =>{Utils.ActiveSliderUI(customAspect.slider, false);switch (val){case "16:9": whAspectValue = 1.777f;break;case "9:16": whAspectValue = 0.5625f;break;case "16:10": whAspectValue = 1.6f;break;case "10:16": whAspectValue = 0.625f;break;case "4:3": whAspectValue = 1.333f;break;case "3:4": whAspectValue = 0.75f;break;case "2:1": whAspectValue = 2f;break;case "1:2": whAspectValue = 0.5f;break;case "1:1": whAspectValue = 1f;break;default:                        whAspectValue = customAspect.val;Utils.ActiveSliderUI(customAspect.slider, true);break;}ChangeRadio();RefreshCamRT();};Utils.CreateSpacer(ower, 20, false);heightPixelCount = Utils.CreateSliderInt(ower, Location.GetStr(Location.HeightPixelAmount), 4096, 2048, 4096, false, ower.bcs);previewHeightPixelCount = Utils.CreateSliderInt(ower, Location.GetStr(Location.PreviewHeightPixelAmount), 480, 64, 1024, false, ower.bcs);previewHeightPixelCount.setCallbackFunction = (val) =>{RefreshCamRT();};startScale = ower.Screen.transform.localScale;aspectChooser.setCallbackFunction(aspectChooser.val);intensity.setCallbackFunction(intensity.val);nearCLip.setCallbackFunction(nearCLip.val);farClip.setCallbackFunction(farClip.val);isFrontCamera.setCallbackFunction(isFrontCamera.val);RefreshCamRT();}public override void OnUpdate(){base.OnUpdate();}private void ChangeRadio(){ower.CurrentCam.aspect = whAspectValue;ower.Screen.transform.localScale = new Vector3(startScale.x * camScale.val, startScale.x * camScale.val / whAspectValue, startScale.z * camScale.val);}private void RefreshCamRT(){RenderTexture.ReleaseTemporary(previewRT);int w = (int)(previewHeightPixelCount.val * whAspectValue);int h = (int)previewHeightPixelCount.val;captureRTSize.x = (int)(heightPixelCount.val * whAspectValue);captureRTSize.y = (int)heightPixelCount.val;previewRT = RenderTexture.GetTemporary(w, h, 24, RenderTextureFormat.ARGB32);ower.CurrentCam.targetTexture = previewRT;ower.Screen.material.mainTexture = previewRT;}public override void UnInit(){RenderTexture.ReleaseTemporary(previewRT);}}}