/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using MVR.FileManagementSecure;using System.Linq;using System;namespace PluginIdea.HandleCameraForCreator{public class PicCapModule : HCModuleBase{struct PicCapState{public const int IDLE = 0;public const int DELAYING = 1;public const int CAPING = 2;}private const string SHOT_DIRECTORY = "Saves/CameraShot/";private JSONStorableStringChooser layerChooser;private JSONStorableFloat takeShotDelay;private JSONStorableString delayTimerTextView;private JSONStorableAction takeShotAction;private List<string> layerList = new List<string>();private Texture2D currentTextureCaptured;private AudioSource hcAudioSource;private float delayTimer;private int picCapState = PicCapState.IDLE;private string delayStr;public PicCapModule(HandleCameraForCreator ower){this.ower = ower;}public override void Init(){Utils.CreateSpacer(ower, 30, true);Utils.CreateInfoTextNoScroll(this.ower, Location.GetStr(Location.TakeShotSubtitle), 35, true);takeShotDelay = Utils.CreateSliderFloat(ower, Location.GetStr(Location.Delay), 0f, 0f, 10f, true, ower.bcs);Utils.CreateButton(this.ower, Location.GetStr(Location.TakeaShot), CaptureAPicture, true, ower.bcs);Utils.CreateButton(this.ower, Location.GetStr(Location.CancelDelayTimer), RemoveLastTimer, true, ower.bcs);delayTimerTextView = Utils.CreateInfoText(ower, "", 30, true);delayTimerTextView.text.color = Color.red;takeShotAction = Utils.SetupAction(ower, "Take A Shot", CaptureAPicture);hcAudioSource = Utils.GetSafeComponent<AudioSource>(ower.CurrentCam.gameObject);}public override void OnUpdate(){base.OnUpdate();if (picCapState == PicCapState.DELAYING){delayTimer -= Time.deltaTime;delayStr = Mathf.Ceil(delayTimer).ToString();delayTimerTextView.text.text = string.Format("<b>Will TakeAShot At{0}s</b>", delayStr);}}private void SavePicture(){string filename = GetFilename();filename += ".jpg";byte[] bytes = currentTextureCaptured.EncodeToJPG(100);FileManagerSecure.CreateDirectory(SHOT_DIRECTORY);string path = SHOT_DIRECTORY + filename;FileManagerSecure.WriteAllBytes(path, bytes);SuperController.LogMessage("Took a picture success : " + path);}private Coroutine currentCorotine;private void CaptureAPicture(){RemoveLastTimer();picCapState = PicCapState.DELAYING;delayTimer = takeShotDelay.val;currentCorotine = ower.StartCoroutine(Utils.WaitTimeCall(takeShotDelay.val, () =>{hcAudioSource.Stop();hcAudioSource.Play();Camera tempRenderCam = new GameObject("TempRenderCam").AddComponent<Camera>();tempRenderCam.CopyFrom(ower.CurrentCam);RenderTexture captureRT = RenderTexture.GetTemporary(ower.CModule.CaptureRTSize.x, ower.CModule.CaptureRTSize.y);tempRenderCam.targetTexture = captureRT;Rect rect = new Rect(0, 0, captureRT.width, captureRT.height);if (currentTextureCaptured != null) GameObject.Destroy(currentTextureCaptured);ower.StartCoroutine(Utils.WaitTimeCall(0.1f, () =>{currentTextureCaptured = Utils.CameraCapture(tempRenderCam, rect, captureRT);SavePicture();GameObject.Destroy(tempRenderCam.gameObject);RenderTexture.ReleaseTemporary(captureRT);picCapState = PicCapState.IDLE;}));}));}private void RemoveLastTimer(){if (currentCorotine != null) ower.StopCoroutine(currentCorotine);picCapState = PicCapState.IDLE;delayStr = "";}public string GetFilename(){return ((int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds).ToString();}public override void UnInit(){if (currentTextureCaptured != null) GameObject.Destroy(currentTextureCaptured);}}}